{
  description = "NixOS Machine Configurations by manuth";

  inputs = {
    nixpkgs.url = "nixpkgs/38c01297e7ec11f7b9e3f2cae7d6fcec6cc767ec";
  };

  outputs = { self, nixpkgs }: 
    let
      system = import ./lib/system.nix {
        inherit nixpkgs;
      };
      systems = [
        {
          name = "nixos";
        }
      ];
    in {
      nixosConfigurations = builtins.listToAttrs
        (
          builtins.map (
            { name, config ? {} }:
              {
                inherit name;
                value = system name config;
              })
            systems);
    };
}
